Require TheoryList.

Theorem AllS_In:
 (A:Set)(P:A -> Prop)
  (l: (list A))(x:A)
   (AllS P l) -> (In x l) -> (P x).
Proof.
 Intros A P l x;
 Elim l;
  [ Intros;
    Elim H0
  | Intros;
    Inversion H0;
    Simpl in H1;
    Elim H1;
     [ Intro;
       Rewrite <- H6;
       Assumption
     | Apply H;
       Assumption
     ]
  ].
Qed.

Section Fold_Left_i_Recursor.
Variables A,B:Set.
Variable  f:nat->A->B->A.
Fixpoint fold_left_i [l:(list B)] : nat -> A -> A :=
[n][a0]Cases l of
      nil      => a0
  | (cons b t) => (fold_left_i t (S n) (f n a0 b))
  end.
End Fold_Left_i_Recursor.
