Require RAMs.
Require Linda.
Require PolyList.
Require TheoryList_compl.
Require Gt.
Require Lt.
Require Le.
Require Plus.
Require Compare_dec.
Require Arith_compl.
Require Peano_dec.
Require RAMs_to_Linda.
Require Minus.
Require Suresnes.BDD.rauzy.algorithme1.Prelude_BDT.
Require MiscRsa.
Require RAMs_to_Linda_proofs.
Require Rocq.SUBST.comparith.
Require Decidable.

Axiom Daemon: False.

Lemma RAM_image_decjump_message_multiplicity_not_O_Tau_RAM_image_out_pc:
 (registers_no:nat ; r:message ; pc,pc':nat ; P,P':agent)
   (lt r registers_no) ->
   ~(message_multiplicity r P)=O ->
    (is_RAM_image_decjump registers_no r pc' pc P) ->
     (OStep P Tau P') ->
      (is_RAM_image_out_pc registers_no (S pc) P').
Proof.
 Intros;
 Generalize P' H2;
 Clear P' H2;
 Induction H1;
  [ Intros;
    Inversion H2
  | Intros;
    Elim (eq_nat_dec (message_multiplicity r P) O);
     [ Intro;
       Inversion H3;
        [ Elim
           (RAM_image_decjump_Tau_not_message_multiplicity_O
             ? ? ? ? ? ? H1 H9 a)
        | Elim (stuck_RAM_image_no_pc ? ? H2);
          Exists P'0;
          Left;
          Assumption
        | Apply IRIOPCAParallel1;
           [ Generalize
              (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H2 H7);
             Intro Hlt;
             Apply
              (RAM_image_decjump_LIn_is_RAM_image_out_pc
                ? ? ? ? ? ? ? Hlt H1 H6)
           | Apply (RAM_image_no_pc_LOut_RAM_image_no_pc ? ? ? ? H2 H7)
           ]
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H2 H7);
          Intro Hge;
          Generalize
           (RAM_image_decjump_LOut_lt_registers_no ? ? ? ? ? ? ? H1 H6);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim
           (RAM_image_decjump_not_LRead ? ? ? ? ? ? ? H1 H6)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H2 H7)
        ]
     | Intro;
       Inversion H3;
        [ Apply IRIOPCAParallel1;
           [ Apply HrecH1;
              [ Assumption
              | Assumption
              ]
           | Assumption
           ]
        | Elim (stuck_RAM_image_no_pc ? ? H2);
          Exists P'0;
          Left;
          Assumption
        | Apply IRIOPCAParallel1;
           [ Generalize
              (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H2 H7);
             Intro Hlt;
             Apply
              (RAM_image_decjump_LIn_is_RAM_image_out_pc
                ? ? ? pc ? ? ? Hlt H1 H6)
           | Apply (RAM_image_no_pc_LOut_RAM_image_no_pc ? ? ? ? H2 H7)
           ]
        | Generalize
           (RAM_image_decjump_LOut_lt_registers_no ? ? ? ? ? ? ? H1 H6);
          Intro Hlt;
          Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H2 H7);
          Intro Hge;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim
           (RAM_image_decjump_not_LRead ? ? ? ? ? ? ? H1 H6)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H2 H7)
        ]
     ]
  | Intros;
    Elim (eq_nat_dec (message_multiplicity r Q) O);
     [ Intro;
       Inversion H3;
        [ Elim (stuck_RAM_image_no_pc ? ? H1);
          Exists P'0;
          Left;
          Assumption
        | Elim
           (RAM_image_decjump_Tau_not_message_multiplicity_O
             ? ? ? ? ? ? H2 H9 a)
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H1 H6);
          Intro Hge;
          Generalize
           (RAM_image_decjump_LOut_lt_registers_no ? ? ? ? ? ? ? H2 H7);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Apply IRIOPCAParallel2;
           [ Apply (RAM_image_no_pc_LOut_RAM_image_no_pc ? ? ? ? H1 H6)
           | Generalize
              (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H1 H6);
             Intro Hlt;
             Apply
              (RAM_image_decjump_LIn_is_RAM_image_out_pc
                ? ? ? ? ? ? ? Hlt H2 H7)
           ]
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H1 H6)
        | Elim
           (RAM_image_decjump_not_LRead ? ? ? ? ? ? ? H2 H7)
        ]
     | Intro;
       Inversion H3;
        [ Elim (stuck_RAM_image_no_pc ? ? H1);
          Exists P'0;
          Left;
          Assumption
        | Apply IRIOPCAParallel2;
           [ Assumption
           | Apply HrecH1;
              [ Assumption
              | Assumption
              ]
           ]
        | Generalize
           (RAM_image_decjump_LOut_lt_registers_no ? ? ? ? ? ? ? H2 H7);
          Intro Hlt;
          Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H1 H6);
          Intro Hge;
          Elim (le_not_lt ? ? Hge Hlt)
        | Apply IRIOPCAParallel2;
           [ Apply (RAM_image_no_pc_LOut_RAM_image_no_pc ? ? ? ? H1 H6)
           | Generalize
              (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H1 H6);
             Intro Hlt;
             Apply
              (RAM_image_decjump_LIn_is_RAM_image_out_pc
                ? ? ? pc ? ? ? Hlt H2 H7)
           ]
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H1 H6)
        | Elim
           (RAM_image_decjump_not_LRead ? ? ? ? ? ? ? H2 H7)
        ]
     ]
  ].
Qed.

Lemma RAM_image_no_pc_LIn_message_multiplicity_eq:
 (registers_no:nat ; m,m':message ; P,P': agent)
  (is_RAM_image_no_pc registers_no P) ->
   (OStep P (LIn m) P') ->
    (message_multiplicity m' P)=(message_multiplicity m' P').
Proof.
 Intros;
 Generalize P' H0;
 Clear P' H0;
 Induction H;
  [ Intros;
    Inversion H0
  | Intros;
    Inversion H2;
     [ Simpl;
       Rewrite (HrecH1 ? H7);
       Reflexivity
     | Simpl;
       Rewrite (HrecH0 ? H7);
       Reflexivity
     ]
  | Intros;
    Inversion H0
  | Intros;
    Inversion H1;
    Reflexivity
  ].
Qed.

Lemma is_RAM_image_decjump_LIn_message_multiplicity_eq:
 (registers_no:nat; r,m:register; pc,pc':nat; P,P':agent)
  (is_RAM_image_decjump registers_no r pc' pc P) ->
   (OStep P (LIn r) P') ->
    (message_multiplicity m P)=(message_multiplicity m P').
Proof.
 Intros;
 Generalize P' H0;
 Clear P' H0;
 Induction H;
  [ Intros;
    Inversion H0;
    Reflexivity
  | Intros;
    Inversion H1;
     [ Simpl;
       Rewrite (HrecH ? H7);
       Reflexivity
     | Simpl;
       Rewrite (RAM_image_no_pc_LIn_message_multiplicity_eq ? ? m ? ? H0 H7);
       Reflexivity
     ]
  | Intros;
    Inversion H1;
     [ Simpl;
       Rewrite (RAM_image_no_pc_LIn_message_multiplicity_eq ? ? m ? ? H H7);
       Reflexivity
     | Simpl;
       Rewrite (HrecH ? H7);
       Reflexivity
     ]
  ].
Qed.

Lemma is_RAM_image_decjump_Tau_message_multiplicity_decr:
 (registers_no:nat; r:register; pc,pc':nat; P,P':agent)
  (is_RAM_image_decjump registers_no r pc' pc P) ->
   (OStep P Tau P') ->
    (message_multiplicity r P)=(S (message_multiplicity r P')).
Proof.
 Intros;
 Generalize P' H0;
 Clear P' H0;
 Induction H;
  [ Intros;
    Inversion H0
  | Intros;
    Inversion H1;
     [ Simpl;
       Rewrite (HrecH ? H7);
       Reflexivity
     | Elim (stuck_RAM_image_no_pc ? ? H0);
       Exists P'0;
       Left;
       Assumption
     | Elim
        (RAM_image_decjump_LIn_eq_or_ge_registers_no ? ? ? ? ? ? ? H H4);
        [ Intro;
          Rewrite H7 in H4;
          Simpl;
          Rewrite
           (is_RAM_image_decjump_LIn_message_multiplicity_eq
             ? ? r ? ? ? ? H H4);
          Rewrite H7 in H5;
          Rewrite (LOut_message_multiplicity_decr ? ? ? H5);
          Rewrite plus_n_Sm;
          Reflexivity
        | Intro Hge;
          Generalize
           (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H0 H5);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        ]
     | Generalize
        (RAM_image_decjump_LOut_lt_registers_no ? ? ? ? ? ? ? H H4);
       Intro Hlt;
       Generalize
        (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H0 H5);
       Intro Hge;
       Elim (le_not_lt ? ? Hge Hlt)
     | Elim
        (RAM_image_decjump_not_LRead ? ? ? ? ? ? ? H H4)
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H0 H5)
     ]
  | Intros;
    Inversion H1;
     [ Elim (stuck_RAM_image_no_pc ? ? H);
       Exists P'0;
       Left;
       Assumption
     | Simpl;
       Rewrite (HrecH ? H7);
       Rewrite plus_n_Sm;
       Reflexivity
     | Generalize
        (RAM_image_decjump_LOut_lt_registers_no ? ? ? ? ? ? ? H0 H5);
       Intro Hlt;
       Generalize
        (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H H4);
       Intro Hge;
       Elim (le_not_lt ? ? Hge Hlt)
     | Elim
        (RAM_image_decjump_LIn_eq_or_ge_registers_no ? ? ? ? ? ? ? H0 H5);
        [ Intro;
          Rewrite H7 in H5;
          Simpl;
          Rewrite
           (is_RAM_image_decjump_LIn_message_multiplicity_eq
             ? ? r ? ? ? ? H0 H5);
          Rewrite H7 in H4;
          Rewrite (LOut_message_multiplicity_decr ? ? ? H4);
          Reflexivity
        | Intro Hge;
          Generalize
           (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H H4);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        ]
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H H4)
     | Elim
        (RAM_image_decjump_not_LRead ? ? ? ? ? ? ? H0 H5)
     ]
  ].
Qed.

Lemma LOut_message_multiplicity_eq:
 (m,m':message ; P,P': agent)
  ~m=m' ->
   (OStep P (LOut m) P') ->
    (message_multiplicity m' P)=(message_multiplicity m' P').
Proof.
 Induction P;
  [ Intros;
    Inversion H0;
    Simpl;
    Elim (eq_nat_dec m' m);
     [ Simpl;
       Intro;
       Elim H;
       Symmetry;
       Assumption
     | Reflexivity
     ]
  | Intros;
    Inversion H0
  | Intros;
    Simpl;
    Inversion H2;
     [ Rewrite (H ? H1 H8);
       Reflexivity
     | Rewrite (H0 ? H1 H8);
       Reflexivity
     ]
  ].
Qed.

Lemma is_RAM_image_decjump_Tau_message_multiplicity_eq:
 (registers_no:nat; r,m:register; pc,pc':nat; P,P':agent)
  ~r=m ->
   (is_RAM_image_decjump registers_no r pc' pc P) ->
    (OStep P Tau P') ->
     (message_multiplicity m P)=(message_multiplicity m P').
Proof.
 Intros;
 Apply
  (is_RAM_image_decjump_Tau_ind registers_no r pc' pc) with 5 := H0 6 := H1;
  [ Intros;
    Simpl;
    Rewrite H2;
    Reflexivity
  | Intros;
    Simpl;
    Rewrite H2;
    Reflexivity
  | Intros;
    Simpl;
    Rewrite
     (is_RAM_image_decjump_LIn_message_multiplicity_eq
       ? ? m ? ? ? ? H2 H4);
    Rewrite (LOut_message_multiplicity_eq ? ? ? ? H H5);
    Reflexivity
  | Intros;
    Simpl;
    Rewrite
     (is_RAM_image_decjump_LIn_message_multiplicity_eq
       ? ? m ? ? ? ? H3 H5);
    Rewrite (LOut_message_multiplicity_eq ? ? ? ? H H4);
    Reflexivity
  ].
Qed.

Lemma RAM_image_decjump_Tau_almost_deterministic_for_registers_of_agent:
 (registers_no:nat ; r:message ; pc,pc':nat ; P,P',P'':agent)
  (lt r registers_no) ->
   (is_RAM_image_decjump registers_no r pc' pc P) ->
    (OStep P Tau P') -> (OStep P Tau P'') ->
     ((r':nat)
       (registers_of_agent registers_no P' r')=
       (registers_of_agent registers_no P'' r')).
Proof.
 Intros;
 Elim (eq_nat_dec r r');
  [ Intro;
    Rewrite <- a;
    Cut
     (S (registers_of_agent registers_no P' r))
      =(S (registers_of_agent registers_no P'' r));
     [ Intro;
       Injection H3;
       Intro;
       Assumption
     | Unfold registers_of_agent;
       Elim (le_lt_dec registers_no r);
        [ Reflexivity
        | Intro;
          Simpl;
          Apply trans_eq with y:=(message_multiplicity r P);
           [ Apply
              (is_RAM_image_decjump_Tau_ind registers_no r pc' pc)
              with 5:=H0 6:=H1;
              [ Intros;
                Simpl;
                Rewrite <- H3;
                Reflexivity
              | Intros;
                Simpl;
                Rewrite <- H3;
                Rewrite -> plus_n_Sm;
                Reflexivity
              | Intros;
                Simpl;
                Rewrite -> (LOut_message_multiplicity_decr ? ? ? H6);
                Rewrite -> plus_n_Sm;
                Rewrite <-
                (is_RAM_image_decjump_LIn_message_multiplicity_eq
                  ? ? r ? ? ? ? H3 H5);
                Reflexivity
              | Intros;
                Simpl;
                Rewrite -> (LOut_message_multiplicity_decr ? ? ? H5);
                Rewrite <-
                 (is_RAM_image_decjump_LIn_message_multiplicity_eq
                   ? ? r ? ?  ? ? H4 H6);
                Reflexivity
              ]
           | Apply
              (is_RAM_image_decjump_Tau_ind registers_no r pc' pc)
              with 5:=H0 6:=H2;
              [ Intros;
                Simpl;
                Rewrite H3;
                Reflexivity
              | Intros;
                Simpl;
                Rewrite H3;
                Rewrite -> plus_n_Sm;
                Reflexivity
              | Intros;
                Simpl;
                Rewrite -> (LOut_message_multiplicity_decr ? ? ? H6);
                Rewrite -> plus_n_Sm;
                Rewrite <-
                (is_RAM_image_decjump_LIn_message_multiplicity_eq
                  ? ? r ? ? ? ? H3 H5);
                Reflexivity
              | Intros;
                Simpl;
                Rewrite -> (LOut_message_multiplicity_decr ? ? ? H5);
                Rewrite <-
                 (is_RAM_image_decjump_LIn_message_multiplicity_eq
                   ? ? r ? ?  ? ? H4 H6);
                Reflexivity
              ]
           ]
        ]
     ]
  | Intro;
    Apply trans_eq with y := (registers_of_agent registers_no P r');
     [ Unfold registers_of_agent;
       Elim (le_lt_dec registers_no r');
        [ Reflexivity
        | Simpl;
          Intro;
          Apply
           (is_RAM_image_decjump_Tau_ind registers_no r pc' pc)
           with 5:=H0 6:=H1;
           [ Simpl;
             Intros;
             Rewrite H3;
             Reflexivity
           | Simpl;
             Intros;
             Rewrite H3;
             Reflexivity
           | Simpl;
             Intros;
             Rewrite <-
              (is_RAM_image_decjump_LIn_message_multiplicity_eq
                ? ? r' ? ? ? ? H3 H5);
             Rewrite (LOut_message_multiplicity_eq ? ? ? ? b H6);
             Reflexivity
           | Simpl;
             Intros;
             Rewrite <-
              (is_RAM_image_decjump_LIn_message_multiplicity_eq
                ? ? r' ? ? ? ? H4 H6);
             Rewrite (LOut_message_multiplicity_eq ? ? ? ? b H5);
             Reflexivity
           ]
        ]
     | Unfold registers_of_agent;
       Elim (le_lt_dec registers_no r');
        [ Reflexivity
        | Simpl;
          Intro;
          Symmetry;
          Apply
           (is_RAM_image_decjump_Tau_ind registers_no r pc' pc)
           with 5:=H0 6:=H2;
           [ Simpl;
             Intros;
             Rewrite H3;
             Reflexivity
           | Simpl;
             Intros;
             Rewrite H3;
             Reflexivity
           | Simpl;
             Intros;
             Rewrite <-
              (is_RAM_image_decjump_LIn_message_multiplicity_eq
                ? ? r' ? ? ? ? H3 H5);
             Rewrite (LOut_message_multiplicity_eq ? ? ? ? b H6);
             Reflexivity
           | Simpl;
             Intros;
             Rewrite <-
              (is_RAM_image_decjump_LIn_message_multiplicity_eq
                ? ? r' ? ? ? ? H4 H6);
             Rewrite (LOut_message_multiplicity_eq ? ? ? ? b H5);
             Reflexivity
           ]
        ]
     ]
  ].
Qed.

Lemma RAM_image_decjump_Tau_almost_deterministic_for_is_RAM_image_out_pc:
 (registers_no:nat ; r:message ; pc,pc':nat ; P,P',P'':agent)
  (lt r registers_no) ->
   (is_RAM_image_decjump registers_no r pc' pc P) ->
    (OStep P Tau P') -> (OStep P Tau P'') ->
     ((is_RAM_image_out_pc registers_no (S pc) P') <->
       (is_RAM_image_out_pc registers_no (S pc) P'')).
Proof.
 Intros;
 Generalize
  (RAM_image_decjump_Tau_not_message_multiplicity_O ? ? ? ? ? ? H0 H1);
 Intro b;
 Generalize
  (RAM_image_decjump_message_multiplicity_not_O_Tau_RAM_image_out_pc
    ? ? ? ? ? ? H b H0 H1);
 Intro;
 Generalize
  (RAM_image_decjump_message_multiplicity_not_O_Tau_RAM_image_out_pc
    ? ? ? ? ? ? H b H0 H2);
 Intro;
 Split;
  [ Intro;
    Assumption
  | Intro;
    Assumption
  ].
Qed.

Theorem RAM_image_decjump_step:
 (registers_no:nat ; r:message ; pc,pc':nat ; P:agent)
  (ge pc registers_no) -> (ge pc' registers_no) ->
  (is_RAM_image_decjump registers_no r pc' pc P) ->
   {P':agent |
    (step P P') /\
     [pc'' :=
       (Cases (eq_nat_dec (message_multiplicity r P) O) of
           (left _ ) => pc'
         | (right _) => (S pc)
        end)
     ] (ge pc'' registers_no) /\ (is_RAM_image_out_pc registers_no pc'' P')
   }.
Proof.
 Intros;
 Elim (eq_nat_dec (message_multiplicity r P) O);
  [ Intro;
    Elim
     (RAM_image_decjump_message_multiplicity_O_LNot ? ? ? ? ? a H1);
    Intros;
    Case p;
    Intros;
    Exists x;
    Split;
     [ Right;
       Exists r;
       Assumption
     | Split;
        [ Assumption
        | Assumption
        ]
     ]
  | Intro;
    Elim
     (RAM_image_decjump_message_multiplicity_not_O_Tau ? ? ? ? ? b H1);
    Intros;
    Case p;
    Intros;
    Exists x;
    Split;
     [ Left;
       Assumption
     | Split;
        [ Unfold ge;
          Apply le_S;
          Assumption
        | Assumption
        ]
     ]
  ].
Qed.

Lemma RAM_image_decjump_LNot_deterministic':
 (registers_no:nat ; r,m:message ; pc,pc':nat ; P,P':agent)
  (is_RAM_image_decjump registers_no r pc' pc P) ->
   (OStep P (LNot m) P') -> r=m.
Proof.
 Intros;
 Generalize P' H0;
 Clear P' H0;
 Induction H;
  [ Intros;
    Inversion H0;
    Reflexivity
  | Intros;
    Inversion H1;
     [ Apply (HrecH ? H7)
     | Elim (stuck_RAM_image_no_pc ? ? H0);
       Exists P'0;
       Right;
       Exists m;
       Assumption
     | Apply (HrecH ? H5)
     | Elim (stuck_RAM_image_no_pc ? ? H0);
       Exists P'0;
       Right;
       Exists m;
       Assumption
     ]
  | Intros;
    Inversion H1;
     [ Elim (stuck_RAM_image_no_pc ? ? H);
       Exists P'0;
       Right;
       Exists m;
       Assumption
     | Apply (HrecH ? H7)
     | Elim (stuck_RAM_image_no_pc ? ? H);
       Exists P'0;
       Right;
       Exists m;
       Assumption
     | Apply (HrecH ? H5)
     ]
  ].
Qed.

Theorem RAM_image_decjump_step_almost_deterministic:
 (registers_no:nat ; r:message ; pc,pc':nat ; P,P',P'':agent)
  (lt r registers_no) ->
   (is_RAM_image_decjump registers_no r pc' pc P) ->
    (step P P') -> (step P P'') ->
     ((r':nat)
       (registers_of_agent registers_no P' r')=
       (registers_of_agent registers_no P'' r'))
     /\
      [pc'' :=
        (Cases (eq_nat_dec (message_multiplicity r P) O) of
            (left _ ) => pc'
          | (right _) => (S pc)
         end)
      ] (is_RAM_image_out_pc registers_no pc'' P') /\
         (is_RAM_image_out_pc registers_no pc'' P'').
Proof.
 Intros;
 Elim H1;
  [ Intro;
    Cut (OStep P Tau P'');
     [ Intro;
       Split;
        [ Apply
           (RAM_image_decjump_Tau_almost_deterministic_for_registers_of_agent
             ? ? ? ? ? ? ? H H0 H3 H4)
        | Elim (eq_nat_dec (message_multiplicity r P) (0));
	   [ Intros;
	     Unfold pc'';
	     Elim
	      (RAM_image_decjump_Tau_not_message_multiplicity_O
	        ? ? ? ? ? ? H0 H3 a)
	   | Intros;
	     Unfold pc'';
	     Split;
	      [ Apply
	         RAM_image_decjump_message_multiplicity_not_O_Tau_RAM_image_out_pc with 3 := H0 2 := b 4 := H3;
		Assumption
	      | Apply
	         RAM_image_decjump_message_multiplicity_not_O_Tau_RAM_image_out_pc with 3 := H0 2 := b 4 := H4;
		Assumption
	      ]
	   ]
        ]
     | Elim H2;
        [ Intro;
          Assumption
        | Intro;
          Elim H4;
          Intros;
          Generalize
           (RAM_image_decjump_LNot_deterministic' ? ? ? ? ? ? ? H0 H5);
          Intro;
          Rewrite <- H6 in H5;
          Generalize (RAM_image_decjump_Tau_not_LNot ? ? ? ? ? ? P'' H0 H3);
          Intro;
          Elim (H7 H5)
        ]
     ]
  | Intro;
    Elim H3;
    Intros;
    Generalize
     (RAM_image_decjump_LNot_deterministic' ? ? ? ? ? ? ? H0 H4);
    Intro;
    Rewrite <- H5 in H4;
    Elim H2;
     [ Intro;
       Elim (RAM_image_decjump_Tau_not_LNot ? ? ? ? ? ? ? H0 H6 H4)
     | Intro;
       Elim H6;
       Intros;
       Generalize
        (RAM_image_decjump_LNot_deterministic' ? ? ? ? ? ? ? H0 H7);
       Intro;
       Rewrite <- H8 in H7;
       Generalize (RAM_image_decjump_LNot_deterministic ? ? ? ? ? ? ? H0 H4 H7);
       Intro;
       Rewrite H9;
       Split;
        [ Reflexivity
        | Elim (eq_nat_dec (message_multiplicity r P) (0));
	   [ Intros;
	     Unfold pc'';
	     Cut (is_RAM_image_out_pc registers_no pc' P'');
	      [ Intro;
	        Split;
		 [ Assumption
		 | Assumption
		 ]
	      | Elim
                 (RAM_image_decjump_message_multiplicity_O_LNot
		   ? ? ? ? ? a H0);
		Intros;
		Decompose [and] p;
		Rewrite
                 (RAM_image_decjump_LNot_deterministic
		   ? ? ? ? ? ? ? H0 H7 H11);
		Assumption
	      ]
	   | Intros;
	     Elim 
	      (RAM_image_decjump_message_multiplicity_not_O_Tau ? ? ? ? ? b H0);
	     Intros;
	     Decompose [and] p;
             Elim (RAM_image_decjump_Tau_not_LNot ? ? ? ? ? ? ? H0 H11 H4)
	   ]
        ]
     ]
  ].
Qed.

(**     STEP3     **)
Definition step3 :=
 [P,P':agent]
  (EX Q |
   (EX Q' |
    (step P Q) /\ (step Q Q') /\ (step Q' P'))).

Definition is_RAM_image_pc_of_is_RAM_image :=
 [registers_no:nat ; program_length:nat ; P:agent]
  [H:(is_RAM_image registers_no program_length P)]
   Cases H of
    (Build_is_RAM_image H' _ _) => H'
   end.

Definition RAM_image_equivalence' :
 (registers_no:nat ; program_length:nat ; P,P':agent)
  (is_RAM_image registers_no program_length P) ->
   (is_RAM_image registers_no program_length P') ->
    Prop
:=
 [registers_no:nat ; program_length:nat ; P,P':agent]
  [IRI: (is_RAM_image registers_no program_length P)]
   [IRI': (is_RAM_image registers_no program_length P')]
    [H := (is_RAM_image_pc_of_is_RAM_image ? ? ? IRI)]
     [H' := (is_RAM_image_pc_of_is_RAM_image ? ? ? IRI')]
      (RAM_configuration_equality registers_no
       (configuration_of_RAM_image_pc registers_no P H)
       (configuration_of_RAM_image_pc registers_no P' H')).


(* Dependent induction principle *)
Lemma is_RAM_image_pc_ind_dependent:
 (registers_no:nat; P:((a:agent)(is_RAM_image_pc registers_no a)->Prop))
  ((m:nat)(Hge:(ge m registers_no))(P (Message m) (IRIMessage ? m Hge)))
  ->((P0,Q:agent)
      (H:(is_RAM_image_pc registers_no P0))
       (P P0 H) ->
        (H0:(is_RAM_image_no_pc registers_no Q))
         (P (AParallel P0 Q) (IRIAParallel1 registers_no P0 Q H H0)))
  ->((P0,Q:agent)
      (H:(is_RAM_image_no_pc registers_no P0))
       (H0:(is_RAM_image_pc registers_no Q))
        (P Q H0) ->
         (P (AParallel P0 Q) (IRIAParallel2 registers_no P0 Q H H0)))
  ->(a:agent)(H:(is_RAM_image_pc registers_no a))(P a H).
Proof.
 Exact
  [registers_no:nat;
   P:((a:agent)(is_RAM_image_pc registers_no a)->Prop);
   f:((m:nat)(Hge:(ge m registers_no))(P (Message m) (IRIMessage ? m Hge)));
   f0:((P0,Q:agent)
       (H:(is_RAM_image_pc registers_no P0))
        (P P0 H) ->
         (H0:(is_RAM_image_no_pc registers_no Q))
          (P (AParallel P0 Q) (IRIAParallel1 registers_no P0 Q H H0)));
   f1:((P0,Q:agent)
       (H:(is_RAM_image_no_pc registers_no P0))
        (H0:(is_RAM_image_pc registers_no Q))
         (P Q H0) ->
          (P (AParallel P0 Q) (IRIAParallel2 registers_no P0 Q H H0)))]
   Fix F
     {F [a:agent; i:(is_RAM_image_pc registers_no a)] : (P a i) :=
        <P>
          Cases i of
            (IRIMessage m g) => (f m g)
          | (IRIAParallel1 P0 Q i0 i1) => (f0 P0 Q i0 (F P0 i0) i1)
          | (IRIAParallel2 P0 Q i0 i1) => (f1 P0 Q i0 i1 (F Q i1))
          end}.
Qed.

(* Technical induction principle *)
Lemma is_RAM_image_pc_instruction_occurs_once_Tau_ind:
 (registers_no:nat; P:(agent->agent->Prop))
  ((P0,P',Q:agent)
    (H:(is_RAM_image_pc registers_no P0))
     (is_RAM_image_no_pc registers_no Q) ->
      [pc := (pc_of_RAM_image_pc ? ? H)]
       (* This hypothesis can be strengthened *)
       (instruction_occurs_once registers_no pc (AParallel P0 Q)) ->
        (P P0 P') -> (P (AParallel P0 Q) (AParallel P' Q))) ->
  ((P0,Q,Q':agent)
    (is_RAM_image_no_pc registers_no P0) ->
     (H:(is_RAM_image_pc registers_no Q))
      [pc := (pc_of_RAM_image_pc ? ? H)]
       (* This hypothesis can be strengthened *)
       (instruction_occurs_once registers_no pc (AParallel P0 Q)) ->
        (P Q Q') -> (P (AParallel P0 Q) (AParallel P0 Q'))) ->
  ((P0,P',Q,Q':agent ; r:register)
    (H:(is_RAM_image_pc registers_no P0))
     (is_RAM_image_no_pc registers_no Q) ->
      [pc := (pc_of_RAM_image_pc ? ? H)]
       (* This hypothesis can be strengthened *)
       (instruction_occurs_once registers_no pc (AParallel P0 Q)) ->
        (OStep P0 (LOut r) P') ->
         (OStep Q (LIn r) Q') ->
          (P (AParallel P0 Q) (AParallel P' Q'))) ->
  ((P0,P',Q,Q':agent ; r:register)
    (is_RAM_image_no_pc registers_no P0) ->
     (H:(is_RAM_image_pc registers_no Q))
      [pc := (pc_of_RAM_image_pc ? ? H)]
       (* This hypothesis can be strengthened *)
       (instruction_occurs_once registers_no pc (AParallel P0 Q)) ->
        (OStep P0 (LIn r) P') ->
         (OStep Q (LOut r) Q') ->
          (P (AParallel P0 Q) (AParallel P' Q'))) ->
  (a,a':agent)
   (H:(is_RAM_image_pc registers_no a))
    [pc := (pc_of_RAM_image_pc ? ? H)]
     (instruction_occurs_once registers_no pc a) ->
     (OStep a Tau a') ->
      (P a a').
Proof.
 Intros registers_no P H H0 H1 H2 a a' H3;
 Generalize a';
 Clear a';
 Elim H3 using is_RAM_image_pc_ind_dependent;
  [ Intros;
    Inversion H5
  | Intros;
    Inversion H8;
     [ Cut pc=(pc_of_RAM_image_pc registers_no P0 H4);
        [ Intro;
          Apply (H ? P' ? H4 H6);
           [ Rewrite <- H15;
             Assumption
           | Apply H5 with 2 := H14;
             Inversion H7;
              [ Rewrite <- H15;
                Assumption
              | Rewrite H15 in H18;
                Elim
                 (is_RAM_image_pc_instruction_does_not_occur_not_Tau
                   ? ? ? H4 H18 H14)
              ]
           ]
        | Unfold pc;
          Apply pc_of_AParallel_equal_pc1
        ]
     | Elim (stuck_RAM_image_no_pc ? ? H6);
       Exists P';
       Left;
       Assumption
     | Generalize
        (RAM_image_pc_LIn_ge_registers_no ? ? ? ? H4 H11);
       Intro Hge;
       Generalize
        (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H6 H12);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Cut pc=(pc_of_RAM_image_pc registers_no P0 H4);
        [ Intro;
          Rewrite H14 in H7;
          Apply (H1 ? ? ? ? ? H4 H6 H7 H11 H12)
        | Unfold pc;
          Apply pc_of_AParallel_equal_pc1
        ]
     | Elim (RAM_image_pc_no_LRead ? ? ? ? H4 H11)
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H6 H12)
     ]
  | Intros;
    Inversion H8;
     [ Elim (stuck_RAM_image_no_pc ? ? H4);
       Exists P';
       Left;
       Assumption
     | Cut pc=(pc_of_RAM_image_pc registers_no Q H5);
        [ Intro;
          Apply (H0 ? ? P' H4 H5);
           [ Rewrite <- H15;
             Assumption
           | Apply H6 with 2 := H14;
             Inversion H7;
              [ Rewrite H15 in H19;
                Elim
                 (is_RAM_image_pc_instruction_does_not_occur_not_Tau
                   ? ? ? H5 H19 H14)
              | Rewrite <- H15;
                Assumption
              ]
           ]
        | Unfold pc;
          Apply pc_of_AParallel_equal_pc2
        ]
     | Cut pc=(pc_of_RAM_image_pc registers_no Q H5);
        [ Intro;
          Rewrite H14 in H7;
          Apply (H2 ? ? ? ? ? H4 H5 H7 H11 H12)
        | Unfold pc;
          Apply pc_of_AParallel_equal_pc2
        ]
     | Generalize
        (RAM_image_pc_LIn_ge_registers_no ? ? ? ? H5 H12);
       Intro Hge;
       Generalize
        (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H4 H11);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H4 H11)
     | Elim (RAM_image_pc_no_LRead ? ? ? ? H5 H12)
     ]
  ].
Qed.

Inductive instruction_does_not_occur2 [registers_no:nat; n:nat] : agent -> Prop
:=
   IOO0Message2 :
    (m:message)(instruction_does_not_occur2 registers_no n (Message m))
 | IOO0Dead2 :
    (instruction_does_not_occur2 registers_no n (Program Dead))
 | IOO0BangIn2 :
    (P:program ; m:message)
     (is_RAM_instruction registers_no m P) ->
     ~m=n ->
     (instruction_does_not_occur2
       registers_no n (Program (Action (BangIn m) P)))
 | IOO0Step2 :
    (pc:nat ; P:program)
     (is_RAM_instruction registers_no pc P) ->
      (instruction_does_not_occur2 registers_no n (Program P))
 | IOO0Parallel12 :
    (P,Q:agent)
     (instruction_does_not_occur2 registers_no n P) ->
      (instruction_does_not_occur registers_no n Q) ->
       (instruction_does_not_occur2 registers_no n (AParallel P Q))
 | IOO0Parallel22 :
    (P,Q:agent)
     (instruction_does_not_occur registers_no n P) ->
      (instruction_does_not_occur2 registers_no n Q) ->
       (instruction_does_not_occur2 registers_no n (AParallel P Q)).


Lemma instruction_does_not_occur_LOut_instruction_does_not_occur:
 (registers_no:nat ; n,m:nat; P,P':agent)
  (instruction_does_not_occur registers_no n P) ->
   (OStep P (LOut m) P') ->
    (instruction_does_not_occur registers_no n P').
Proof.
 Intros;
 Generalize P' H0;
 Clear P' H0;
 Elim H;
  [ Intros;
    Inversion H0;
    Constructor
  | Intros;
    Inversion H0
  | Intros;
    Inversion H2
  | Intros;
    Inversion H4;
     [ Apply IOO0Parallel;
        [ Apply (H1 ? H10)
        | Assumption
        ]
     | Apply IOO0Parallel;
        [ Assumption 
        | Apply (H3 ? H10)
        ]
     ]
  ].
Qed.

Lemma RAM_image_no_pc_instruction_does_not_occur_LIn_instruction_does_not_occur2:
 (registers_no:nat ; n,m:nat; P,P':agent)
  (is_RAM_image_no_pc registers_no P) ->
   (instruction_does_not_occur registers_no n P) ->
    (OStep P (LIn m) P') ->
     (instruction_does_not_occur2 registers_no n P').
Proof.
 Intros;
 Generalize P' H1;
 Clear P' H1;
 Induction H0;
  [ Intros;
    Inversion H1
  | Intros;
    Inversion H1
  | Intros;
    Inversion H2;
    Inversion H;
    Constructor;
     [ Inversion H10;
        [ Apply IOO0Step2 with pc := m0;
          Constructor;
          Assumption
        | Apply IOO0Step2 with pc := m0;
          Constructor;
           [ Assumption
           | Assumption
           ]
        ]
     | Constructor;
        [ Rewrite <- H6;
          Assumption
        | Rewrite <- H6;
          Assumption
        ]
     ]
  | Intros;
    Inversion H;
    Inversion H1;
     [ Apply IOO0Parallel12;
        [ Apply (HrecH0_1 H3 ? H10)
        | Assumption
        ]
     | Apply IOO0Parallel22;
        [ Assumption
        | Apply (HrecH0_0 H4 ? H10)
        ]
     ]
  ].
Qed.

Lemma is_RAM_image_pc_RAM_image_pc_instruction_does_not_occur_Tau_instruction_does_not_occur2:
 (registers_no:nat ; n:nat; P,P':agent)
  (ge n registers_no) ->
   (is_RAM_image_pc registers_no P) ->
    (instruction_does_not_occur registers_no n P) ->
     (OStep P Tau P') ->
      (instruction_does_not_occur2 registers_no n P').
Proof.
 Intros;
 Generalize H1 P' H2;
 Clear H1 P' H2;
 Elim H0;
  [ Intros;
    Inversion H3
  | Intros;
    Inversion H5;
     [ Inversion H4;
       Apply IOO0Parallel12;
        [ Apply (H2 H14 ? H11)
        | Assumption
        ]
     | Elim (stuck_RAM_image_no_pc ? ? H3);
       Exists P'0;
       Left;
       Assumption
     | Generalize
        (RAM_image_pc_LIn_ge_registers_no ? ? ? ? H1 H8);
       Intro Hge;
       Generalize
        (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H3 H9);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Inversion H4;
       Apply IOO0Parallel22;
        [ Apply
           (instruction_does_not_occur_LOut_instruction_does_not_occur
             ? ? ? ? ? H13 H8)
        | Apply
           (RAM_image_no_pc_instruction_does_not_occur_LIn_instruction_does_not_occur2
             ? ? ? ? ? H3 H14 H9)
        ]
     | Elim (RAM_image_pc_no_LRead ? ? ? ? H1 H8)
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H3 H9)
     ]
  | Intros;
    Inversion H5;
     [ Elim (stuck_RAM_image_no_pc ? ? H1);
       Exists P'0;
       Left;
       Assumption
     | Inversion H4;
       Apply IOO0Parallel22;
        [ Assumption
        | Apply (H3 H15 ? H11)
        ]
     | Inversion H4;
       Apply IOO0Parallel12;
        [ Apply
           (RAM_image_no_pc_instruction_does_not_occur_LIn_instruction_does_not_occur2
             ? ? ? ? ? H1 H13 H8)
        | Apply
           (instruction_does_not_occur_LOut_instruction_does_not_occur
             ? ? ? ? ? H14 H9)
        ]
     | Generalize
        (RAM_image_pc_LIn_ge_registers_no ? ? ? ? H2 H9);
       Intro Hge;
       Generalize
        (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H1 H8);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H1 H8)
     | Elim (RAM_image_pc_no_LRead ? ? ? ? H2 H9)
     ]
  ].
Qed.

Inductive instruction_does_not_occur3 [registers_no:nat; n:nat] : agent -> Prop
:=
   IOO0Message3 :
    (m:message)(instruction_does_not_occur3 registers_no n (Message m))
 | IOO0Dead3 :
    (instruction_does_not_occur3 registers_no n (Program Dead))
 | IOO0BangIn3 :
    (P:program ; m:message)
     (is_RAM_instruction registers_no m P) ->
     ~m=n ->
     (instruction_does_not_occur3
       registers_no n (Program (Action (BangIn m) P)))
 | IOO0Step3 :
    (pc:nat)
     (instruction_does_not_occur3 registers_no n
       (Program (Action (Out pc) Dead)))
 | IOO0Parallel13 :
    (P,Q:agent)
     (instruction_does_not_occur registers_no n P) ->
      (instruction_does_not_occur3 registers_no n Q) ->
       (instruction_does_not_occur3 registers_no n (AParallel P Q))
 | IOO0Parallel23 :
    (P,Q:agent)
     (instruction_does_not_occur3 registers_no n P) ->
      (instruction_does_not_occur registers_no n Q) ->
       (instruction_does_not_occur3 registers_no n (AParallel P Q)).

Lemma is_RAM_image_no_pc_instruction_does_not_occur2_instruction_does_not_occur3:
 (registers_no:nat ; n:nat; P:agent)
  (is_RAM_image_no_pc registers_no P) ->
   (instruction_does_not_occur2 registers_no n P) ->
    (instruction_does_not_occur3 registers_no n P).
Proof.
 Induction 1;
  [ Constructor
  | Intros;
    Inversion H4;
     [ Apply IOO0Parallel23;
        [ Apply (H1 H7)
        | Assumption
        ]
     | Apply IOO0Parallel13;
        [ Assumption
        | Apply (H3 H8)
        ]
     ]
  | Constructor
  | Intros;
    Inversion H2;
     [ Constructor;
        [ Assumption
        | Assumption
        ]
     | Inversion H4
     ]
  ].
Qed.

Lemma RAM_image_succ_instruction_does_not_occur_LIn_instruction_does_not_occur3:
 (registers_no:nat ; pc:nat; n,m,r:nat; P,P':agent)
  (lt m registers_no) ->
   (is_RAM_image_succ registers_no r pc P) ->
    (instruction_does_not_occur registers_no n P) ->
     (OStep P (LIn m) P') ->
      (instruction_does_not_occur3 registers_no n P').
Proof.
 Intros;
 Generalize P' H2;
 Clear P' H2;
 Induction H1;
  [ Intros;
    Inversion H2
  | Intros;
    Inversion H2
  | Intros;
    Inversion H0
  | Intros;
    Inversion H2;
     [ Apply IOO0Parallel23;
        [ Inversion H0;
           [ Apply (HrecH1_1 H10 ? H7)
           | Generalize
              (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H10 H7);
             Intro Hge;
             Elim (le_not_lt ? ? Hge H)
           ]
        | Assumption
        ]
     | Apply IOO0Parallel13;
        [ Assumption
        | Inversion H0;
           [ Generalize
              (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H11 H7);
             Intro Hge;
             Elim (le_not_lt ? ? Hge H)
           | Apply (HrecH1_0 H11 ? H7)
           ]
        ]
     ]
  ].
Qed.

Lemma RAM_image_succ_instruction_does_not_occur_Tau_instruction_does_not_occur3:
 (registers_no:nat ; pc:nat; n,r:nat; P,P':agent)
  (is_RAM_image_succ registers_no r pc P) ->
   (instruction_does_not_occur registers_no n P) ->
    (OStep P Tau P') ->
     (instruction_does_not_occur3 registers_no n P').
Proof.
 Intros;
 Generalize P' H1;
 Clear P' H1;
 Induction H0;
  [ Inversion H
  | Inversion H
  | Inversion H
  | Inversion H;
     [ Intros;
       Inversion H4;
        [ Apply IOO0Parallel23;
           [ Apply (HrecH0_1 H2 ? H10)
           | Assumption
           ]
        | Apply IOO0Parallel13;
           [ Assumption
           | Elim (stuck_RAM_image_no_pc ? ? H3);
             Exists P'0;
             Left;
             Assumption
           ]
        | Apply IOO0Parallel23;
           [ Generalize
              (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H3 H8);
             Intro Hlt;
             Apply
              (RAM_image_succ_instruction_does_not_occur_LIn_instruction_does_not_occur3
                ? ? ? ? ? ? ? Hlt H2 H0_1 H7)
           | Apply
              (instruction_does_not_occur_LOut_instruction_does_not_occur
                ? ? ? ? ? H0_0 H8)
           ]
        | Generalize
           (RAM_image_succ_LOut_lt_registers_no ? ? ? ? ? ? H2 H7);
          Intro Hlt;
          Generalize (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H3 H8);
          Intro Hge;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_succ_not_LRead ? ? ? ? ? ? H2 H7)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H3 H8)
        ]
     | Intros;
       Inversion H4;
        [ Apply IOO0Parallel23;
           [ Elim (stuck_RAM_image_no_pc ? ? H2);
             Exists P'0;
             Left;
             Assumption
           | Assumption
           ]
        | Apply IOO0Parallel13;
           [ Assumption
           | Apply (HrecH0_0 H3 ? H10)
           ]
        | Generalize
           (RAM_image_succ_LOut_lt_registers_no ? ? ? ? ? ? H3 H8);
          Intro Hlt;
          Generalize (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H2 H7);
          Intro Hge;
          Elim (le_not_lt ? ? Hge Hlt)
        | Apply IOO0Parallel13;
           [ Apply
              (instruction_does_not_occur_LOut_instruction_does_not_occur
                ? ? ? ? ? H0_1 H7)
           | Generalize
              (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H2 H7);
             Intro Hlt;
             Apply
              (RAM_image_succ_instruction_does_not_occur_LIn_instruction_does_not_occur3
                ? ? ? ? ? ? ? Hlt H3 H0_0 H8)
           ]
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H2 H7)
        | Elim (RAM_image_succ_not_LRead ? ? ? ? ? ? H3 H8)
        ]
     ]
  ].
Qed.

Lemma is_RAM_image_no_pc_instruction_does_not_occur2_instruction_does_not_occur:
 (registers_no:nat ; n:nat; P:agent)
  (is_RAM_image_no_pc registers_no P) ->
   (instruction_does_not_occur2 registers_no n P) ->
    (instruction_does_not_occur registers_no n P).
Proof.
 Induction 1;
  [ Constructor
  | Intros;
    Inversion H4;
     [ Apply IOO0Parallel;
        [ Apply (H1 H7)
        | Assumption
        ]
     | Apply IOO0Parallel;
        [ Assumption
        | Apply (H3 H8)
        ]
     ]
  | Constructor
  | Intros;
    Inversion H2;
     [ Constructor;
        [ Assumption
        | Assumption
        ]
     | Inversion H4
     ]
  ].
Qed.

Lemma instruction_does_not_occur_instruction_does_not_occur2:
 (registers_no:nat ; n:nat; P:agent)
  (instruction_does_not_occur registers_no n P) ->
   (instruction_does_not_occur2 registers_no n P).
Proof.
 Induction 1;
  [ Constructor
  | Constructor
  | Constructor;
     [ Assumption
     | Assumption
     ]
  | Constructor;
     [ Assumption
     | Assumption
     ]
  ].
Qed.

Lemma instruction_does_not_occur_instruction_does_not_occur3:
 (registers_no:nat ; n:nat; P:agent)
  (instruction_does_not_occur registers_no n P) ->
   (instruction_does_not_occur3 registers_no n P).
Proof.
 Induction 1;
  [ Constructor
  | Constructor
  | Constructor;
     [ Assumption
     | Assumption
     ]
  | Constructor;
     [ Assumption
     | Assumption
     ]
  ].
Qed.

Lemma RAM_image_succ_instruction_does_not_occur2_Tau_instruction_does_not_occur3:
 (registers_no:nat ; n,r,pc:nat; P,P':agent)
  (ge n registers_no) ->
   (is_RAM_image_succ registers_no r pc P) ->
    (instruction_does_not_occur2 registers_no n P) ->
     (OStep P Tau P') ->
      (instruction_does_not_occur3 registers_no n P').
Proof.
 Intros;
 Generalize H1 P' H2;
 Clear H1 P' H2;
 Elim H0;
  [ Intros;
    Inversion H2;
    Constructor;
     [ Constructor
     | Constructor
     ]
  | Intros;
    Inversion H4;
     [ Inversion H5;
        [ Apply IOO0Parallel23;
           [ Apply (H2 H8 ? H15)
           | Assumption
           ]
        | Elim (stuck_RAM_image_no_pc ? ? H3);
          Exists P'0;
          Left;
          Assumption
        | Generalize
           (RAM_image_succ_LIn_ge_registers_no ? ? ? ? ? ? H1 H12);
          Intro Hge;
          Generalize
           (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H3 H13);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize
           (RAM_image_succ_LOut_lt_registers_no ? ? ? ? ? ? H1 H12);
          Intro Hlt;
          Generalize (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H3 H13);
          Intro Hge;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_succ_not_LRead ? ? ? ? ? ? H1 H12)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H3 H13)
        ]
     | Inversion H5;
        [ Apply IOO0Parallel23;
           [ Apply
              (RAM_image_succ_instruction_does_not_occur_Tau_instruction_does_not_occur3 ? ? ? ? ? ? H1 H8 H15)
           | Apply
              (is_RAM_image_no_pc_instruction_does_not_occur2_instruction_does_not_occur ? ? ? H3 H9)
           ]
        | Elim (stuck_RAM_image_no_pc ? ? H3);
          Exists P'0;
          Left;
          Assumption
        | Generalize
           (RAM_image_succ_LIn_ge_registers_no ? ? ? ? ? ? H1 H12);
          Intro Hge;
          Generalize
           (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H3 H13);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize
           (RAM_image_succ_LOut_lt_registers_no ? ? ? ? ? ? H1 H12);
          Intro Hlt;
          Generalize (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H3 H13);
          Intro Hge;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_succ_not_LRead ? ? ? ? ? ? H1 H12)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H3 H13)
        ]
     ]
  | Intros;
    Inversion H4;
     [ Inversion H5;
        [ Elim (stuck_RAM_image_no_pc ? ? H1);
          Exists P'0;
          Left;
          Assumption
        | Apply IOO0Parallel13;
           [ Apply
              (is_RAM_image_no_pc_instruction_does_not_occur2_instruction_does_not_occur ? ? ? H1 H8)
           | Apply H3;
              [ Apply
                 (instruction_does_not_occur_instruction_does_not_occur2 ? ? ? H9)
              | Assumption
              ]
           ]
        | Apply IOO0Parallel13;
           [ Generalize
              (RAM_image_succ_LOut_lt_registers_no ? ? ? ? ? ? H2 H13);
             Intro Hlt;
             Generalize (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H1 H12);
             Intro Hge;
             Elim (le_not_lt ? ? Hge Hlt)
           | Apply instruction_does_not_occur_instruction_does_not_occur3;
             Apply
              (instruction_does_not_occur_LOut_instruction_does_not_occur
                ? ? ? ? ? H9 H13)
           ]
        | Generalize
           (RAM_image_succ_LIn_ge_registers_no ? ? ? ? ? ? H2 H13);
          Intro Hge;
          Generalize
           (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H1 H12);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H1 H12)
        | Elim (RAM_image_succ_not_LRead ? ? ? ? ? ? H2 H13)
        ]
     | Inversion H5;
        [ Elim (stuck_RAM_image_no_pc ? ? H1);
          Exists P'0;
          Left;
          Assumption
        | Apply IOO0Parallel13;
           [ Assumption
           | Apply (H3 H9 ? H15)
           ]
        | Generalize
           (RAM_image_succ_LOut_lt_registers_no ? ? ? ? ? ? H2 H13);
          Intro Hlt;
          Generalize (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H1 H12);
          Intro Hge;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize
           (RAM_image_succ_LIn_ge_registers_no ? ? ? ? ? ? H2 H13);
          Intro Hge;
          Generalize
           (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H1 H12);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H1 H12)
        | Elim (RAM_image_succ_not_LRead ? ? ? ? ? ? H2 H13)
        ]
     ]
  ].
Qed.

Lemma RAM_image_decjump_instruction_does_not_occur2_Tau_instruction_does_not_occur3:
 (registers_no:nat ; r:message ; n,pc,pc':nat ; P,P':agent)
  (ge n registers_no) ->
   (lt r registers_no) ->
    (is_RAM_image_decjump registers_no r pc' pc P) ->
     (instruction_does_not_occur2 registers_no n P) ->
      (OStep P Tau P') ->
       (instruction_does_not_occur3 registers_no n P').
Proof.
 (* The technical induction principle is ineffective. 
    Induction must be performed by hand. ;-(
 *)
 Elim Daemon.
Qed.

Lemma instruction_does_not_occur_not_LNot:
 (registers_no:nat ; n,m:nat ; P,P':agent)
  (instruction_does_not_occur registers_no n P) ->
    ~(OStep P (LNot m) P').
Proof.
 Unfold not;
 Intros;
 Generalize P' H0;
 Clear P' H0;
 Elim H;
  [ Intros;
    Inversion H0
  | Intros;
    Inversion H0
  | Intros;
    Inversion H2
  | Intros;
    Inversion H4;
     [ Apply (H1 ? H10)
     | Apply (H3 ? H10)
     | Apply (H1 ? H8)
     | Apply (H3 ? H8)
     ]
  ].
Qed.

Lemma RAM_image_decjump_not_instruction_does_not_occur:
 (registers_no:nat ; n,r:message ; pc,pc':nat ; P:agent)
  (is_RAM_image_decjump registers_no r pc' pc P) ->
   ~(instruction_does_not_occur registers_no n P).
Proof.
 Induction 1;
  [ Intro;
    Inversion H0
  | Intros;
    Intro;
    Inversion H3;
    Apply (H1 H6)
  | Intros;
    Intro;
    Inversion H3;
    Apply (H2 H7)
  ].
Qed.

Lemma RAM_image_decjump_instruction_does_not_occur2_LNot_instruction_does_not_occur3:
 (registers_no:nat ; r,m:message ; n,pc,pc':nat ; P,P':agent)
  (ge n registers_no) ->
   (lt r registers_no) ->
    (is_RAM_image_decjump registers_no r pc' pc P) ->
     (instruction_does_not_occur2 registers_no n P) ->
      (OStep P (LNot m) P') ->
       (instruction_does_not_occur3 registers_no n P').
Proof.
 Intros;
 Generalize P' H2 H3;
 Clear P' H2 H3;
 Induction H1;
  [ Intros;
    Inversion H3;
    Constructor
  | Intros;
    Inversion H3;
     [ Inversion H4;
        [ Apply IOO0Parallel23;
	   [ Apply (HrecH1 ? H7 H14)
	   | Assumption
	   ]
	| Elim (stuck_RAM_image_no_pc ? ? H2);
	  Exists P'0;
	  Right;
	  Exists m;
	  Assumption
        | Apply IOO0Parallel23;
	   [ Apply (HrecH1 ? H7 H12)
	   | Assumption
	   ]
	| Elim (instruction_does_not_occur_not_LNot ? ? ? ? ? H8 H12)
	]
     | Elim (RAM_image_decjump_not_instruction_does_not_occur ? ? ? ? ? ? H1 H7)
     ]
  | Intros;
    Inversion H3;
     [ Elim (RAM_image_decjump_not_instruction_does_not_occur ? ? ? ? ? ? H2 H8)
     | Inversion H4;
	[ Elim (stuck_RAM_image_no_pc ? ? H1);
	  Exists P'0;
	  Right;
	  Exists m;
	  Assumption
        | Apply IOO0Parallel13;
	   [ Assumption
	   | Apply (HrecH1 ? H8 H14)
	   ]
	| Elim (instruction_does_not_occur_not_LNot ? ? ? ? ? H7 H12)
        | Apply IOO0Parallel13;
	   [ Assumption
	   | Apply (HrecH1 ? H8 H12)
	   ]
	]
     ]
  ].
Qed.

Lemma RAM_image_decjump_instruction_does_not_occur2_step_instruction_does_not_occur3:
 (registers_no:nat ; r:message ; n,pc,pc':nat ; P,P':agent)
  (ge n registers_no) ->
   (lt r registers_no) ->
    (is_RAM_image_decjump registers_no r pc' pc P) ->
     (instruction_does_not_occur2 registers_no n P) ->
      (step P P') ->
       (instruction_does_not_occur3 registers_no n P').
Proof.
 Intros;
 Elim H3;
  [ Intro;
    Apply
     (RAM_image_decjump_instruction_does_not_occur2_Tau_instruction_does_not_occur3 ? ? ? ? ? ? ? H H0 H1 H2 H4)
  | Intro;
    Decompose [ex] H4;
    Apply
     (RAM_image_decjump_instruction_does_not_occur2_LNot_instruction_does_not_occur3 ? ? ? ? ? ? ? ? H H0 H1 H2 H5)
  ].
Qed.

Lemma RAM_image_out_pc_instruction_does_not_occur_Tau_instruction_does_not_occur:
 (registers_no:nat ; n,pc:nat; P,P':agent)
  (is_RAM_image_out_pc registers_no pc P) ->
   (instruction_does_not_occur registers_no n P) ->
    (OStep P Tau P') ->
     (instruction_does_not_occur registers_no n P').
Proof.
 Intros;
 Generalize P' H1;
 Clear P' H1;
 Induction H0;
  [ Inversion H
  | Inversion H
  | Inversion H
  | Intros;
    Inversion H;
     [ Inversion H1;
        [ Constructor;
           [ Apply (HrecH0_1 H3 ? H10)
           | Assumption
           ]
        | Constructor;
           [ Assumption
           | Elim (stuck_RAM_image_no_pc ? ? H4);
             Exists P'0;
             Left;
             Assumption
           ]
        | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H3 H7);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H4 H8);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H4 H8);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H3 H7);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H3 H7)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H4 H8)
        ]
     | Inversion H1;
        [ Constructor;
           [ Elim (stuck_RAM_image_no_pc ? ? H3);
             Exists P'0;
             Left;
             Assumption
           | Assumption
           ]
        | Constructor;
           [ Assumption
           | Apply (HrecH0_0 H4 ? H10)
           ]
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H3 H7);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H4 H8);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H4 H8);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H3 H7);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H3 H7)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H4 H8)
        ]
     ]
  ].
Qed.

Lemma is_RAM_image_no_pc_instruction_does_not_occur3_instruction_does_not_occur:
 (registers_no:nat ; n:nat; P:agent)
  (is_RAM_image_no_pc registers_no P) ->
   (instruction_does_not_occur3 registers_no n P) ->
    (instruction_does_not_occur registers_no n P).
Proof.
 Induction 1;
  [ Constructor
  | Intros;
    Inversion H4;
     [ Constructor;
        [ Assumption
        | Apply (H3 H8)
        ]
     | Constructor;
        [ Apply (H1 H7)
        | Assumption
        ]
     ]
  | Constructor
  | Intros;
    Inversion H2;
    Constructor;
     [ Assumption
     | Assumption
     ]
  ].
Qed.

Lemma RAM_image_out_pc_instruction_does_not_occur3_Tau_instruction_does_not_occur:
 (registers_no:nat ; n,pc:nat; P,P':agent)
  (ge n registers_no) ->
   (is_RAM_image_out_pc registers_no pc P) ->
    (instruction_does_not_occur3 registers_no n P) ->
     (OStep P Tau P') ->
      (instruction_does_not_occur registers_no n P').
Proof.
 Intros;
 Generalize P' H2;
 Clear P' H2;
 Induction H1;
  [ Intros;
    Inversion H2
  | Intros;
    Inversion H2
  | Intros;
    Inversion H3
  | Intros;
    Inversion H2;
    Constructor;
     [ Constructor
     | Constructor
     ]
  | Intros;
    Inversion H0;
     [ Inversion H3;
        [ Constructor;
           [ Apply
              (RAM_image_out_pc_instruction_does_not_occur_Tau_instruction_does_not_occur ? ? ? ? ? H6 H1 H13)
           | Apply
              (is_RAM_image_no_pc_instruction_does_not_occur3_instruction_does_not_occur ? ? ? H7 H2)
           ]
        | Elim (stuck_RAM_image_no_pc ? ? H7);
          Exists P'0;
          Left;
          Assumption
        | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H6 H10);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H7 H11);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H7 H11);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H6 H10);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H6 H10)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H7 H11)
        ]
     | Inversion H3;
        [ Elim (stuck_RAM_image_no_pc ? ? H6);
          Exists P'0;
          Left;
          Assumption
        | Constructor;
           [ Assumption
           | Apply (HrecH1 H7 ? H13)
           ]
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H6 H10);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H7 H11);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H7 H11);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H6 H10);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H6 H10)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H7 H11)
        ]
     ]
  | Intros;
    Inversion H0;
     [ Inversion H3;
        [ Constructor;
           [ Apply (HrecH1 H6 ? H13)
           | Assumption
           ]
        | Elim (stuck_RAM_image_no_pc ? ? H7);
          Exists P'0;
          Left;
          Assumption
        | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H6 H10);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H7 H11);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H7 H11);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H6 H10);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H6 H10)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H7 H11)
        ]
     | Inversion H3;
        [ Elim (stuck_RAM_image_no_pc ? ? H6);
          Exists P'0;
          Left;
          Assumption
        | Constructor;
           [ Apply
              (is_RAM_image_no_pc_instruction_does_not_occur3_instruction_does_not_occur ? ? ? H6 H1)
           | Apply
              (RAM_image_out_pc_instruction_does_not_occur_Tau_instruction_does_not_occur ? ? ? ? ? H7 H2 H13)
           ]
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H6 H10);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H7 H11);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H7 H11);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H6 H10);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H6 H10)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H7 H11)
        ]
     ]
  ].
Qed.

(* We can really strengthen the conclusion here. See next theorem. *)
Theorem is_RAM_image_step3_inv:
 (registers_no:nat ; program_length:nat; P,P':agent)
  (is_RAM_image registers_no program_length P) ->
   (step3 P P') ->
    (EX Q |
     (EX Q' |
      (is_RAM_image_pc registers_no P) /\ 
      ((OStep Q Tau Q') /\
       (EX r |
       (H:(is_RAM_image_pc registers_no P))
        (is_RAM_image_succ registers_no r
         (pc_of_RAM_image_pc registers_no P H) Q) /\
        (is_RAM_image_out_pc registers_no
         (S (pc_of_RAM_image_pc registers_no P H)) Q')
       ) \/
       (*CSC: This should be made much more precise *)
       (step Q Q') /\
       (EX r |
        (EX pc' |
          (lt r registers_no) /\ (ge pc' registers_no) /\
          (H:(is_RAM_image_pc registers_no P))
           (is_RAM_image_decjump registers_no r pc'
            (pc_of_RAM_image_pc registers_no P H) Q) /\
            [pc'' :=
              (Cases (eq_nat_dec (message_multiplicity r Q) O) of
                  (left _ ) => pc'
                | (right _) => (S (pc_of_RAM_image_pc registers_no P H))
               end)
	    ] (ge pc'' registers_no) /\
               (is_RAM_image_out_pc registers_no pc'' Q'))
      )) /\
         ((n:nat)
           (lt n program_length) ->
            (instruction_occurs_once registers_no (plus registers_no n) P)) /\
         (OStep P Tau Q) /\ (OStep Q' Tau P')
    )).
Proof.
 Intros;
 Unfold step3 in H0;
 Elim H0;
 Intros Q H1;
 Elim H1;
 Intros Q' H2;
 Decompose [and] H2;
 Clear H0 H1 H2;
 Elim H;
 Intros;
 Exists Q;
 Exists Q';
 Elim H3;
  [ Clear H3;
    Intro;
    Elim (is_RAM_image_pc_instruction_occurs_once_Tau ? ? H0);
     [ Intros;
       Elim p;
       Intros;
       Cut (instruction_occurs_once registers_no (pc_of_RAM_image_pc ? ? H0) P);
        [ Intro;
          Rewrite
           (is_RAM_image_pc_instruction_occurs_once_Tau_deterministic
             ? ? ? ? H0 H8 H4 H3) in H7;
          Clear p H4;
          Elim H7;
          Intros;
          Clear H7;
          Decompose [and] H4;
          Clear H4;
          Elim H9;
           [ Clear H9;
             Intros;
             Elim H5;
              [ Clear H5;
                Intro;
                Elim
                 (RAM_image_succ_Tau_RAM_image_out_pc
                   registers_no x0 (pc_of_RAM_image_pc registers_no P H0) Q)
                 with 2 := H4;
                  [ Intros;
                    Elim p;
                    Intros;
                    Rewrite
                     (RAM_image_succ_Tau_deterministic
                       ? ? ? ? ? ? H4 H10 H5) in H9;
                    Clear H10 p x1;
                    (* Here I prove the goal in the case RAM_image_succ *)
                    Split;
                     [ Assumption
                     | Split;
                        [ Left;
                          Split;
                           [ Assumption
                           | Exists x0;
                             Intro;
                             Split;
                              [ Rewrite
                                 (pc_of_RAM_image_pc_proof_irrelevant
                                   ? ? H10 H0);
                                Assumption
                              | Rewrite
                                 (pc_of_RAM_image_pc_proof_irrelevant
                                   ? ? H10 H0);
                                Assumption
                              ]
                           ]
                        | Split;
                           [ Assumption
                           | Split;
                              [ Assumption
                              | Elim H6;
                                 [ Intro;
                                   Assumption
                                 | Intro;
                                   Elim H10;
                                   Intros;
                                   Elim
                                    (RAM_image_out_pc_not_LNot ? ? ? ? ?
                                      H9 H11)
                                 ]
                              ]
                           ]
                        ]
                     ]
                  | Assumption
                  ]
              | Intro;
                Elim H9;
                Intros;
                Elim (RAM_image_succ_not_LNot ? ? ? ? ? ? H4 H10)
              ]
           | Clear H9;
             Intros;
             Elim H4;
             Clear H4;
             Intros;
             (* Here I prove the goal in the case RAM_image_decjump *)
             Split;
              [ Assumption
              | Split;
                 [ Right;
                   Split;
                    [ Assumption
                    | Exists x0;
                      Exists x1;
                      Split;
                       [ Assumption
                       | Decompose [and] H4;
                         Split;
                          [ Assumption
                          | Intro;
                            Rewrite
                             (pc_of_RAM_image_pc_proof_irrelevant ? ? H11 H0);
                            Split;
                             [ Assumption
                             | Cut
                                (ge
                                  (pc_of_RAM_image_pc registers_no P H0)
                                  registers_no);
                                [ Intro;
                                  Elim
                                   (RAM_image_decjump_step ? ? ? ? ? H12
                                     H9 H10);
                                  Intros;
                                  Decompose [and ex] p;
				  Elim H14;
                                  Intros;
                                  Split;
                                   [ Assumption
                                   | Fold pc'' in H16;
			             Elim
			            (RAM_image_decjump_step_almost_deterministic
				      ? ? ? ? ? ? ? H7 H10 H5 H13);
				     Intros;
				     Elim H18;
				     Intros;
				     Assumption
				   ]
                                | Apply
                                   (pc_of_RAM_image_pc_ge_registers_no ? ? H0)
                                ]
                             ]
                          ]
                       ]
                    ]
                 | Split;
                    [ Assumption
                    | Split;
                       [ Assumption
                       | Elim H6;
                          [ Intro;
                            Assumption
                          | Intro;
                            Decompose [ex] H9;
                            Clear H9;
                            Decompose [and] H4;
                            Clear H4;
                            Elim RAM_image_decjump_step with 2:=H9 3:=H11;
                             [ Intros;
                               Simpl in p;
			       Decompose [and] p;
			       Clear p;
			       Elim
			        (RAM_image_decjump_step_almost_deterministic
				  ? ? ? ? ? ? ? H7 H11 H5 H4);
                               Intros;
			       Elim H15;
			       Intros;
                               Elim
			        (RAM_image_out_pc_not_LNot ? ? ? ? ? H16 H10)
                             | Apply pc_of_RAM_image_pc_ge_registers_no
                             ]
                          ]
                       ]
                    ]
                 ]
              ]
           ]
        | Generalize (pc_of_RAM_image_pc_ge_registers_no ? ? H0);
          Intro Hge;
          Elim (le_witness ? ? Hge);
          Intros;
          Rewrite <- p0;
          Apply H1;
          Generalize
           (is_RAM_image_Tau_lt_pc_plus_registers_no_program_length ? ? ? ?
             H H3);
          Intros;
          Rewrite (pc_of_RAM_image_eq_pc_of_RAM_image_pc ? ? ? H H0) in H8;
          Rewrite <- p0 in H8;
          Apply (simpl_lt_plus_l ? ? ? H8)
        ]
     | Generalize (pc_of_RAM_image_pc_ge_registers_no ? ? H0);
       Intro Hge;
       Elim (le_witness ? ? Hge);
       Intros;
       Rewrite <- p;
       Apply H1;
       Generalize
        (is_RAM_image_Tau_lt_pc_plus_registers_no_program_length ? ? ? ?
          H H3);
       Intros;
       Rewrite (pc_of_RAM_image_eq_pc_of_RAM_image_pc ? ? ? H H0) in H4;
       Rewrite <- p in H4;
       Apply (simpl_lt_plus_l ? ? ? H4)
     ]
  | Intro;
    Elim H4;
    Intros;
    Elim (RAM_image_pc_no_LNot ? ? H0);
    Exists x;
    Exists Q;
    Assumption
  ].
Qed.

Theorem is_RAM_image_step3_is_RAM_image:
 (registers_no:nat ; program_length:nat; P,P':agent)
  (is_RAM_image registers_no program_length P) ->
   (step3 P P') ->
    (is_RAM_image registers_no program_length P').
Proof.
 Intros;
 Generalize (is_RAM_image_step3_inv ? ? ? ? H H0);
 Intro;
 Decompose [and or ex] H1;
  [ Clear H1;
    Elim (H4 H2);
    Clear H4;
    Intros;
    Constructor;
     [ Elim RAM_image_out_pc_Tau_RAM_image_pc with 2:= H4;
        [ Intros;
	  Decompose [and exT] p;
	  Clear p;
          Rewrite (RAM_image_out_pc_Tau_deterministic ? ? ? ? ?  H4 H8 H7);
	  Assumption
	| Unfold ge;
	  Apply le_S;
          Apply pc_of_RAM_image_pc_ge_registers_no
	]
     | Intros;
       Generalize (H6 ? H7);
       Intro;
       Elim Daemon
     | Intros;
       Cut (instruction_does_not_occur registers_no (plus registers_no n) P);
	[ Intro;
	  Cut (ge (plus registers_no n) registers_no);
	   [ Intro Hge;
	     Generalize
              (is_RAM_image_pc_RAM_image_pc_instruction_does_not_occur_Tau_instruction_does_not_occur2 ? ? ? ? Hge H2 H9 H5);
	     Intro;
             Generalize
              (RAM_image_succ_instruction_does_not_occur2_Tau_instruction_does_not_occur3 ? ? ? ? ? ? Hge H1 H10 H3);
	     Intro;
	     Apply
	      (RAM_image_out_pc_instruction_does_not_occur3_Tau_instruction_does_not_occur ? ? ? ? ? Hge H4 H11 H8)
	   | Unfold ge;
	     Apply le_plus_l
	   ]
	| Elim H;
	  Intros;
	  Apply H11;
	  Assumption
	]
     ]
  | Clear H1;
    Elim (H8 H2);
    Clear H8;
    Intros;
    Elim H8;
    Clear H8;
    Intros;
    Constructor;
     [ Elim RAM_image_out_pc_Tau_RAM_image_pc with 2:= H9;
        [ Intros;
	  Decompose [and exT] p;
	  Clear p;
          Rewrite (RAM_image_out_pc_Tau_deterministic ? ? ? ? ?  H9 H10 H11);
	  Assumption
	| Elim (eq_nat_dec (message_multiplicity x1 x) (0));
	   [ Intro;
	     Assumption
	   | Intro;
	     Unfold ge;
	     Apply le_S;
             Apply pc_of_RAM_image_pc_ge_registers_no
	   ]
	]
     | Intros;
       Generalize (H7 ? H11);
       Intro;
       Elim Daemon
     | Intros;
       Cut (instruction_does_not_occur registers_no (plus registers_no n) P);
	[ Intro;
	  Cut (ge (plus registers_no n) registers_no);
	   [ Intro Hge;
	     Generalize
              (is_RAM_image_pc_RAM_image_pc_instruction_does_not_occur_Tau_instruction_does_not_occur2 ? ? ? ? Hge H2 H12 H5);
	     Intro;
             Generalize
              (RAM_image_decjump_instruction_does_not_occur2_step_instruction_does_not_occur3 ? ? ? ? ? ? ? Hge H4 H1 H13 H3);
	     Intro;
	     Apply
	      (RAM_image_out_pc_instruction_does_not_occur3_Tau_instruction_does_not_occur ? ? ? ? ? Hge H9 H14 H10)
	   | Unfold ge;
	     Apply le_plus_l
	   ]
	| Elim H;
	  Intros;
	  Apply H14;
	  Assumption
	]
     ]
  ].
Qed.

Lemma RAM_image_out_pc_Tau_registers_of_agent_eq:
 (registers_no:nat ; r:register ; pc:nat; P,P':agent)
  ~r=pc ->
   (is_RAM_image_out_pc registers_no pc P) ->
    (OStep P Tau P') ->
     (registers_of_agent registers_no P r) =
      (registers_of_agent registers_no P' r).
Proof.
 Intros registers_no r pc P P' H;
 Unfold registers_of_agent;
 Elim (le_lt_dec registers_no r);
  [ Reflexivity
  | Simpl;
    Intros;
    Generalize P' H1;
    Clear P' H1;
    Induction H0;
     [ Intros;
       Inversion H1;
       Simpl;
       Elim (eq_nat_dec r pc);
        [ Intro;
          Elim (H a)
        | Reflexivity
        ]
     | Intros;
       Inversion H2;
        [ Simpl;
          Apply eq_plus_reg_l;
          Apply (HrecH0 ? H8) 
        | Elim (stuck_RAM_image_no_pc ? ? H1);
          Exists P'0;
          Left;
          Assumption
        | Simpl;
          Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H0 H5);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H1 H6);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H1 H6);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H0 H5);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H0 H5)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H1 H6)
        ]
     | Intros;
       Inversion H2;
        [ Elim (stuck_RAM_image_no_pc ? ? H0);
          Exists P'0;
          Left;
          Assumption
        | Simpl;
          Apply eq_plus_reg_r;
          Apply (HrecH0 ? H8) 
        | Generalize
           (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H0 H5);
          Intro Hge;
          Generalize
           (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H1 H6);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Simpl;
          Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H1 H6);
          Intro Hge;
          Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H0 H5);
          Intro Hlt;
          Elim (le_not_lt ? ? Hge Hlt)
        | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H0 H5)
        | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H1 H6)
        ]
     ]
  ].
Qed.

Lemma RAM_image_out_pc_Tau_pc_of_RAM_image_pc_eq:
 (registers_no:nat ; pc:nat; P,P':agent)
   (is_RAM_image_out_pc registers_no pc P) ->
    (H:(is_RAM_image_pc registers_no P'))
     (OStep P Tau P') ->
      (pc_of_RAM_image_pc registers_no P' H) = pc.
Proof.
 Intros;
 Generalize P' H0 H1;
 Clear P' H0 H1;
 Elim H using is_RAM_image_out_pc_ind;
  [ Intros;
    Inversion H1;
    Generalize H0;
    Rewrite <- H2;
    Intro;
    Simpl;
    Elim (le_lt_dec registers_no pc);
     [ Reflexivity
     | Intro;
       Inversion H5;
        [ Inversion H8;
          Elim (le_not_lt ? ? H11 b)
        | Inversion H9
        ]
     ]
  | Intros;
    Inversion H4;
     [ Generalize H3;
       Rewrite <- H9;
       Intro;
       Simpl;
       Elim (is_RAM_image_pc_decidable registers_no P'0);
        [ Intro;
          Simpl;
          Apply (H1 ? a H10)
        | Intro;
          ElimType False;
          Inversion H11;
           [ Apply (b H14)
           | Apply (is_RAM_image_no_pc_not_is_RAM_image_pc ? ? H2 H15)
           ]
        ]
     | Elim (stuck_RAM_image_no_pc ? ? H2);
       Exists P'0;
       Left;
       Assumption
     | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H0 H7);
       Intro Hge;
       Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H2 H8);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Generalize
        (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H2 H8);
       Intro Hge;
       Generalize
        (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H0 H7);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H0 H7)
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H2 H8)
     ]
  | Intros;
    Inversion H4;
     [ Elim (stuck_RAM_image_no_pc ? ? H0);
       Exists P'0;
       Left;
       Assumption
     | Generalize H3;
       Rewrite <- H9;
       Intro;
       Simpl;
       Elim (is_RAM_image_pc_decidable registers_no P'0);
        [ Intro;
          Simpl;
          Elim (is_RAM_image_pc_decidable registers_no P0);
           [ Intro;
             ElimType False;
             Inversion H11;
              [ Apply (is_RAM_image_no_pc_not_is_RAM_image_pc ? ? H15 a)
              | Apply (is_RAM_image_no_pc_not_is_RAM_image_pc ? ? H14 a0)
              ]
           | Intro;
             Simpl;
             Apply (H2 ? a H10)
           ]
        | Intro;
          ElimType False;
          Inversion H11;
           [ Apply (is_RAM_image_no_pc_not_is_RAM_image_pc ? ? H0 H14)
           | Apply (b H15)
           ]
        ]
     | Generalize
        (RAM_image_no_pc_LIn_ge_registers_no ? ? ? ? H0 H7);
       Intro Hge;
       Generalize
        (RAM_image_out_pc_LOut_lt_registers_no ? ? ? ? ? H1 H8);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Generalize (RAM_image_out_pc_LIn_ge_registers_no ? ? ? ? ? H1 H8);
       Intro Hge;
       Generalize (RAM_image_no_pc_LOut_lt_registers_no ? ? ? ? H0 H7);
       Intro Hlt;
       Elim (le_not_lt ? ? Hge Hlt)
     | Elim (RAM_image_no_pc_no_LRead ? ? ? ? H0 H7)
     | Elim (RAM_image_out_pc_not_LRead ? ? ? ? ? H1 H8)
     ]
  ].
Qed.

(* A technical axiom about dependent types + proof-irrelevance     *)
(* Used to overcome the usual difficulty about dependent-types and *)
(* equality. This axiom should be equivalent ot the John-Major     *)
(* equality's corresponding axiom.                                 *)
Axiom pc_of_RAM_image_pc_dependent_proof_irrelevant:
 (registers_no:nat; P,P':agent)
  (H:(is_RAM_image_pc registers_no P))
   (H':(is_RAM_image_pc registers_no P'))
    P=P' ->
     (pc_of_RAM_image_pc registers_no P H) =
      (pc_of_RAM_image_pc registers_no P' H').

(* A technical lemma about dependent types + proof-irrelevance *)
Lemma is_RAM_image_pc_of_is_RAM_image_dependent_proof_irrelevant:
 (registers_no:nat; program_length:nat; P,P':agent)
  (H:(is_RAM_image registers_no program_length P))
   (H':(is_RAM_image registers_no program_length P'))
    P=P' ->
     (pc_of_RAM_image_pc registers_no P
      (is_RAM_image_pc_of_is_RAM_image registers_no program_length P H)) =
     (pc_of_RAM_image_pc registers_no P'
      (is_RAM_image_pc_of_is_RAM_image registers_no program_length P' H')).
Proof.
 Intros;
 Unfold is_RAM_image_pc_of_is_RAM_image;
 Elim H using is_RAM_image_ind_dependent;
 Intros;
 Elim H' using is_RAM_image_ind_dependent;
 Intros;
 Apply pc_of_RAM_image_pc_dependent_proof_irrelevant;
 Assumption.
Qed.

Lemma RAM_image_succ_not_RAM_image_decjump:
 (registers_no:nat; r,r':register; pc,pc',pc'':nat; P:agent)
  (is_RAM_image_succ registers_no r pc P) ->
   ~(is_RAM_image_decjump registers_no r' pc' pc'' P).
Proof.
 Unfold not;
 Intros;
 Generalize H;
 Clear H;
 Elim H0 using is_RAM_image_decjump_ind;
  [ Intro;
    Inversion H
  | Intros;
    Inversion H3;
     [ Apply (H1 H6)
     | Apply (is_RAM_image_no_pc_not_is_RAM_image_succ ? ? ? ? H2 H7)
     ]
  | Intros;
    Inversion H3;
     [ Apply (is_RAM_image_no_pc_not_is_RAM_image_succ ? ? ? ? H H6)
     | Apply (H2 H7)
     ]
  ].
Qed.

Theorem step3_almost_deterministic:
 (registers_no:nat ; program_length:nat; P,P',P'':agent)
  (is_RAM_image registers_no program_length P) ->
   (step3 P P') -> (step3 P P'') ->
    (H: (is_RAM_image registers_no program_length P'))
     (H':(is_RAM_image registers_no program_length P''))
      (RAM_image_equivalence' registers_no program_length P' P'' H H').
Proof.
 Intros;
 Elim (is_RAM_image_step3_inv ? ? ? ? H H0);
 Intros;
 Elim (is_RAM_image_step3_inv ? ? ? ? H H1);
 Intros;
 Decompose [ex and] H3;
 Decompose [ex and] H4;
 Cut x=x0;
  [ Intro;
    Rewrite <- H14 in H13;
    Elim H5;
     [ Intro;
       Cut x1=x2;
        [ Intro;
          Decompose [and ex] H16;
          Generalize (H20 H6);
          Intro;
          Decompose [and] H19;
          Rewrite <- H17 in H15;
          Generalize
           (RAM_image_out_pc_Tau_deterministic ? ? ? ? ?  H22 H10 H15);
          Intro;
          Constructor;
           [ Rewrite
              (is_RAM_image_pc_of_is_RAM_image_dependent_proof_irrelevant
               ? ? ? ? H2 H' H23);
             Reflexivity
           | Rewrite H23;
             Reflexivity
           ]
        | Decompose [and ex] H16;
          Generalize (H19 H6);
          Intro;
          Decompose [and] H18;
          Elim H9;
           [ Intro;
             Decompose [and] H22;
             Rewrite <- H14 in H23;
             Symmetry;
             Apply (RAM_image_succ_Tau_deterministic ? ? ? ? ? ? H20 H23 H17)
           | Intro;
             Decompose [and ex] H22;
             Generalize (H27 H6);
             Intro;
             Decompose [and] H26;
             Rewrite <- H14 in H28;
             Elim (RAM_image_succ_not_RAM_image_decjump ? ? ? ? ? ? ? H20 H28)
           ]
        ]
     | Intro;
       Decompose [ex and] H16;
       Generalize (H21 H6);
       Intro;
       Clear H21 H16 H5 H4 H3;
       Elim H9;
        [ Intro;
          Decompose [and ex] H3;
          Clear H3;
          Generalize (H16 H6);
          Intros;
          Decompose [and] H3;
          Decompose [and] H20;
          Rewrite <- H14 in H5;
          Elim
           (RAM_image_succ_not_RAM_image_decjump ? ? ? ? ? ? ? H5 H22)
        | Intro;
          Clear H9;
          Decompose [ex and] H3;
          Clear H3;
          Generalize (H21 H6);
          Clear H21;
          Intro;
          Decompose [and] H20;
          Clear H20;
          Decompose [and] H3;
          Clear H3;
          Rewrite <- H14 in H20;
          Decompose [ex] H21;
          Clear H21;
          Decompose [ex] H22;
          Clear H22;
          Rewrite <- H14 in H4;
          Elim
           (RAM_image_decjump_step_almost_deterministic ? ? ? ? ? ? ?
             H19 H16 H17 H4);
          Intros;
	  Simpl in H21;
          Decompose [and] H21;
          Clear H21;
          Constructor;
           [ Apply (f_equal2 nat nat);
              [ Rewrite
                 (RAM_image_out_pc_Tau_pc_of_RAM_image_pc_eq ? ? ? ?
                   H22
                    (is_RAM_image_pc_of_is_RAM_image registers_no program_length
                      P' H2)
                   H10);
                Rewrite
                 (RAM_image_out_pc_Tau_pc_of_RAM_image_pc_eq ? ? ? ?
                   H23
                    (is_RAM_image_pc_of_is_RAM_image registers_no program_length
                      P'' H')
                   H15);
                Reflexivity
              | Reflexivity
              ]
           | Intros;
	     Cut
	      (ge
	        (Cases (eq_nat_dec (message_multiplicity x3 x) (0)) of
	            (left _) => x4
		  | (right _) => (S (pc_of_RAM_image_pc registers_no P H6))
                end)
		registers_no);
              [ Intro;
                Cut
		 ~r=
	          (Cases (eq_nat_dec (message_multiplicity x3 x) (0)) of
	              (left _) => x4
		    | (right _) => (S (pc_of_RAM_image_pc registers_no P H6))
                  end);
		 [ Intro;
                   Rewrite <-
                    (RAM_image_out_pc_Tau_registers_of_agent_eq
                      ? ? ? ? ? H25 H22 H10);
                   Rewrite <-
                    (RAM_image_out_pc_Tau_registers_of_agent_eq
                      ? ? ? ? ? H25 H23 H15);
		   Apply H3
		 | Intro;
		   Rewrite <- H25 in H24;
		   Elim (le_not_lt ? ? H24 H21)
		 ]
	      | Elim (eq_nat_dec (message_multiplicity x3 x) (0));
		 [ Intro;
		   Assumption
		 | Intro;
		   Unfold ge;
		   Apply le_S;
		   Apply (pc_of_RAM_image_pc_ge_registers_no ? ? H6)
		 ]
              ]
           ]
        ]
     ]
  | Apply
     is_RAM_image_pc_instruction_occurs_once_Tau_deterministic
      with H := H11;
     [ Generalize (pc_of_RAM_image_pc_ge_registers_no ? ? H11);
       Intro Hge;
       Elim (le_witness ? ? Hge);
       Intros;
       Rewrite <- p;
       Apply H12;
       Generalize
        (is_RAM_image_Tau_lt_pc_plus_registers_no_program_length ? ? ? ?  H H8);
       Intro;
       Rewrite (pc_of_RAM_image_eq_pc_of_RAM_image_pc ? ? ? H H11) in H14;
       Rewrite <- p in H14;
       Apply (simpl_lt_plus_l ? ? ? H14)
     | Assumption
     | Assumption
     ]
  ].
Qed.

Theorem RAM_stuck_iff_Linda_step3_stuck:
 (r:RAM ; c:configuration)
  (RAMs.stuck r c) <->
  (TransitionSystems.stuck ? step3 (agent_of_RAM_and_configuration r c)).
Proof.
 Intros;
 Generalize (RAM_stuck_iff_Linda_stuck r c);
 Intro;
 Apply iff_trans with b := (Linda.stuck (agent_of_RAM_and_configuration r c));
  [ Assumption
  | Clear H;
    Unfold Linda.stuck;
    Unfold TransitionSystems.stuck;
    Split;
     [ Intro;
       Unfold not;
       Intro;
       Apply H;
       Unfold step3 in H0;
       Decompose [ex and] H0;
       Exists x0;
       Assumption
     | Intro;
       Unfold not;
       Intro;
       Apply H;
       Elim H0;
       Intros;
       Generalize (agent_of_RAM_and_configuration_is_RAM_image r c);
       Intro;
       Elim (is_RAM_image_stuck_iff_ge_pc_program_length ? ? ? H2);
       Intros;
       Unfold step3;
       Elim H1;
        [ Intro;
          Generalize H3 H4;
          Clear H3 H4;
          Elim H2;
          Intros;
          Cut
           [P:=(agent_of_RAM_and_configuration r c)]
            [registers_no:=(registers_number r)]
             (instruction_occurs_once registers_no
              (pc_of_RAM_image_pc registers_no P H3) P);
           [ Intro;
             Elim
              (is_RAM_image_pc_instruction_occurs_once_Tau ? ? H3);
              [ Intros;
                Decompose [and ex] p;
                Clear p;
                Rewrite
                 (is_RAM_image_pc_instruction_occurs_once_Tau_deterministic
                   ? ? ? ? H3 H9 H10 H5) in H13;
                Clear H10;
                Elim H13;
                 [ (* Case succ *)
                   Clear H13;
                   Intro;
                   Elim
                    (RAM_image_succ_Tau_RAM_image_out_pc ? ? ? ? H11 H10);
                   Intros;
                   Decompose [and] p;
                   Clear p;
                   Cut
                    (ge
                      (S
                       (pc_of_RAM_image_pc (registers_number r)
                        (agent_of_RAM_and_configuration r c) H3))
                      (registers_number r));
                    [ Intro;
                      Elim
                       (RAM_image_out_pc_Tau_RAM_image_pc ? ? ? H14 H12);
                      Intros;
                      Decompose [and] p;
                      Clear p;
                      Exists x3;
                      Exists x;
                      Exists x2;
                      Split;
                       [ Assumption
                       | Split;
                          [ Left;
                            Assumption
                          | Left;
                            Assumption
                          ]
                       ]
                    | Unfold ge;
                      Apply le_S;
                      Apply (pc_of_RAM_image_pc_ge_registers_no ? ? H3)
                    ]
                 | (* Case decjump *)
                   Clear H13;
                   Intro;
                   Decompose [ex and] H10;
                   Clear H10;
                   Elim RAM_image_decjump_step with 3 := H14;
                    [ Intros;
		      Simpl in p;
                      Decompose [ex and] p;
                      Clear p;
                      Elim
                       (RAM_image_out_pc_Tau_RAM_image_pc ? ? ? H15 H16);
                      Intros;
                      Decompose [and] p;
                      Clear p;
                      Exists x4;
                      Exists x;
                      Exists x3;
                      Split;
                       [ Assumption
                       | Split;
                          [ Assumption
                          | Left;
                            Assumption
                          ]
                       ]
                    | Apply (pc_of_RAM_image_pc_ge_registers_no ? ? H3)
                    | Assumption
                    ]
                 ]
              | Assumption
              ]
           | Simpl;
             Generalize (pc_of_RAM_image_pc_ge_registers_no ? ? H3);
             Intro;
             Elim (le_witness ? ? H9);
             Intros;
             Rewrite <- p;
             Apply H4;
             Elim (le_lt_dec (length (RAMs.program r)) x0);
              [ Intro;
                Elim H8;
                 [ Unfold ge;
                   Cut
                    (pc_of_RAM_image (registers_number r)
                     (length (RAMs.program r))
                      (agent_of_RAM_and_configuration r c) H2) =
                    (pc_of_RAM_image_pc (registers_number r)
                              (agent_of_RAM_and_configuration r c) H3);
                    [ Intro;
                      Rewrite H10;
                      Rewrite <- p;
                      Apply le_reg_l;
                      Assumption
                    | Apply
                       (pc_of_RAM_image_eq_pc_of_RAM_image_pc ? ? ? H2 H3)
                    ]
                 | Exists x;
                   Assumption
                 ]
              | Intro;
                Assumption
              ]
           ]
        | Intro;
          Decompose [ex] H5;
          Elim H2;
          Intros;
          Elim (RAM_image_pc_no_LNot ? ? H7);
          Exists x0;
          Exists x;
          Assumption
        ]
     ]
  ].
Qed.

(* This can be proved, but it would be the easy and uninteresting part of *)
(* the development. Soundness is the most challenging property.           *)
Axiom RAMs_to_Linda_completeness:
 (r:RAM ; c,c':configuration)
  (RAMs.step r c c') ->
   (step3
    (agent_of_RAM_and_configuration r c)
    (agent_of_RAM_and_configuration r c')).

Theorem RAMs_to_Linda_soundness:
 (r:RAM ; c:configuration; P':agent)
  (H:(step3 (agent_of_RAM_and_configuration r c) P'))
    (EX c':configuration |
      (exT ?
        [H0:(RAMs.step r c c')]
         [Hc := (agent_of_RAM_and_configuration_is_RAM_image r c)]
          [Hc' := (is_RAM_image_step3_is_RAM_image ? ? ? ? Hc H)]
           [Hc'' := (agent_of_RAM_and_configuration_is_RAM_image r c')]
            (RAM_image_equivalence' ? ? P' (agent_of_RAM_and_configuration r c')
              Hc' Hc''))).
Proof.
 Intros;
 Cut (EX c':configuration | (RAMs.step r c c'));
  [ Intro;
    Decompose [ex] H0;
    Exists x;
    Exists H1;
    Generalize
     (RAMs_to_Linda_completeness ? ? ? H1);
    Intro;
    Apply
     (step3_almost_deterministic ? ? ? ? ?
      (agent_of_RAM_and_configuration_is_RAM_image r c)
      H H2)
  | Elim (RAM_stuck_iff_Linda_step3_stuck r c);
    Intros;
    Elim (RAMs.stuck_decidable r c);
     [ Intro;
       Elim (H0 a);
       Exists P';
       Assumption
     | Intro;
       Unfold RAMs.stuck in b;
       Unfold TransitionSystems.stuck in b;
       Elim (step_decidable r c);
        [ Intro;
          Assumption
        | Intro;
          Elim (b b0)
        ]
     ]
  ].
Qed.

(* CSC: nice, it can be proved
Theorem RAMs_to_Linda_soundness2:
 (registers_no:nat; program_length:nat; P,P':agent)
  (H:(is_RAM_image registers_no program_length P))
   [H1 := (is_RAM_image_pc_of_is_RAM_image ? ? ? H)]
   (H2:(step3 P P'))
    [H3 := (is_RAM_image_step3_is_RAM_image ? ? ? ? H H2)]
     [H4 := (is_RAM_image_pc_of_is_RAM_image ? ? ? H3)]
      (RAMs.step
       (RAM_of_RAM_image P)
       (configuration_of_RAM_image_pc ? P H1)
       (configuration_of_RAM_image_pc ? P' H4).
Proof.
Qed.
*)
