Require Relations_2.

Definition deterministic :=
 [U:Set ; R: U -> U -> Prop]
  (x,y,z:U)
   (R x y) -> (R x z) -> y=z.

Definition total :=
 [U:Set ; R: U -> U -> Prop]
  (x:U){y:U | (R x y)}.

Definition step_plus :=
 [configuration:Set ; step: configuration -> configuration -> Prop]
  (Relations_2.Rplus configuration step).

Definition step_star :=
 [configuration:Set ; step: configuration -> configuration -> Prop]
  (Relations_2.Rstar configuration step).

Definition stuck :=
 [configuration:Set; step: configuration -> configuration -> Prop]
  [c:configuration]
   ~(EX c' | (step c c')).

Definition reduces :=
 [configuration:Set ; step: configuration -> configuration -> Prop]
  [c,c':configuration](step_star ? step c c') /\ (stuck ? step c').
